﻿namespace UltraTabbedMdiManagerButtons
{
    using System.Drawing;
    using Infragistics.Win;

    internal class DF : IUIElementDrawFilter
    {
        private Image nextButtonImage;
        private Image prevButtonImage;

        public DF(Image prevButtonImage, Image nextButtonImage)
        {
            this.prevButtonImage = prevButtonImage;
            this.nextButtonImage = nextButtonImage;
        }

        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            var spinScrollButtonElement = drawParams.Element as SpinScrollButtonUIElement;
            if(spinScrollButtonElement != null)
            {
                if(drawPhase == DrawPhase.BeforeDrawForeground)
                    return true;

                switch(spinScrollButtonElement.ScrollButtonType)
                {
                    case System.Windows.Forms.ScrollButton.Left:
                        drawParams.AppearanceData.ImageBackground = this.prevButtonImage;
                        break;
                    case System.Windows.Forms.ScrollButton.Right:
                        drawParams.AppearanceData.ImageBackground = this.nextButtonImage;
                        break;
                }

                drawParams.AppearanceData.ImageBackgroundStyle = ImageBackgroundStyle.Stretched;
            }

            return false;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if(drawParams.Element is SpinScrollButtonUIElement)
                return DrawPhase.BeforeDrawElement | DrawPhase.BeforeDrawForeground;

            return DrawPhase.None;
        }
    }
}